Summary: OLPC XO power management
Name: olpc-powerd
Version: 10
Release: 1%{?dist}
License: GPLv2+
Group: System Environment/Base
URL: http://dev.laptop.org/git/users/pgf/powerd/tree/powerd
# Source0: the source tarball is created by "make tarball" from within
# a clone of this git tree: git://dev.laptop.org/users/pgf/powerd
Source0: olpc-powerd-10-git34fc8ac.tar.gz
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildRequires: kernel-headers
Requires: olpc-kbdshim, upstart

# these are all for the manipulation of ohmd -- powerd doesn't need them.
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(post): initscripts
Requires(preun): initscripts

ExclusiveArch: %{ix86}

%description
The powerd daemon can function as an easily customizable replacement for ohmd,
which is independent of X, dbus, and hald.  This package provides the powerd
and olpc-switchd daemons, and related utilities.

%prep
%setup -q

%build
export OPT_FLAGS="$RPM_OPT_FLAGS"
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_sbindir}
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/event.d
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/powerd
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/powerd/postresume.d

%{__install} -p -m 755 olpc-switchd $RPM_BUILD_ROOT/%{_sbindir}/olpc-switchd
%{__install} -p -m 755 powerd $RPM_BUILD_ROOT/%{_sbindir}/powerd
%{__install} -p -m 755 pnmto565fb $RPM_BUILD_ROOT/%{_bindir}/pnmto565fb
%{__install} -p -m 755 powerd-config $RPM_BUILD_ROOT/%{_bindir}/powerd-config
%{__install} -p -m 644 olpc-switchd.upstart $RPM_BUILD_ROOT%{_sysconfdir}/event.d/olpc-switchd
%{__install} -p -m 644 powerd.upstart $RPM_BUILD_ROOT%{_sysconfdir}/event.d/powerd
%{__install} -p -m 644 pleaseconfirm.pgm $RPM_BUILD_ROOT%{_sysconfdir}/powerd/pleaseconfirm.pgm
%{__install} -p -m 644 shuttingdown.pgm $RPM_BUILD_ROOT%{_sysconfdir}/powerd/shuttingdown.pgm
%{__install} -p -m 644 powerd.conf.dist $RPM_BUILD_ROOT%{_sysconfdir}/powerd/powerd.conf


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc COPYING

%{_sbindir}/olpc-switchd
%{_sbindir}/powerd
%{_bindir}/pnmto565fb
%{_bindir}/powerd-config
%config(noreplace) %{_sysconfdir}/event.d/olpc-switchd
%config(noreplace) %{_sysconfdir}/event.d/powerd
%config(noreplace) %{_sysconfdir}/powerd/pleaseconfirm.pgm
%config(noreplace) %{_sysconfdir}/powerd/shuttingdown.pgm
%config(noreplace) %{_sysconfdir}/powerd/powerd.conf

%post
# Only on install
if [ $1 = 1 ] ; then
    if test -e /etc/init.d/ohmd ; then
        service ohmd stop >/dev/null 2>&1
        chkconfig ohmd off 
    fi
    initctl -q start powerd
    initctl -q start olpc-switchd
fi
exit 0

%preun
# Only on uninstall
if [ $1 = 0 ] ; then
    initctl stop -q olpc-switchd
    initctl stop -q powerd
    if test -e /etc/init.d/ohmd
    then
        /sbin/service ohmd start >/dev/null 2>&1
        /sbin/chkconfig ohmd on
    fi
fi
exit 0

%postun
# Restart after upgrade
if [ "$1" -ge "1" ] ; then
    initctl stop -q olpc-switchd
    initctl stop -q powerd
    initctl start -q powerd
    initctl start -q olpc-switchd
fi
exit 0

%changelog
* Thu Aug 13 2009 Paul Fox <pgf@laptop.org>
- 10-1
- prevent running on non-XO hardware
- workaround rtcwake bug
- prevent console spew, by redirecting stderr weven when not logging.

* Thu Jul 30 2009 Paul Fox <pgf@laptop.org>
- 9-1
- disable tracing, by default.  use "powerd-control =tracing-on"
    to enable at runtime.
- create the inhibit file so that root owns it and can make it writeable.
- don't brighten the screen on wlan wakeups.

* Fri Jul 17 2009 Paul Fox <pgf@laptop.org>
- 8-1
- incorporate package review fixups
- commentary and powerd-config UI clarification
- fix fatal bug when battery is missing

* Fri Jul 6 2009 Paul Fox <pgf@laptop.org>
- 7-1
- no longer wake on AC events -- unnecessary
- doc fixups

* Thu Jun 11 2009 Paul Fox <pgf@laptop.org>
- 6-2
- utility targets in makefile

* Sat Jun 6 2009 Paul Fox <pgf@laptop.org>
- 6-1
- various fixes
- incorporate lessons from kbdshim review

* Tue May 5 2009 Paul Fox <pgf@laptop.org>
- 5-1
- fixed ability to shut down with backlight off.  oops.
- various utility bug fixes (powerd-config, olpc-brightness)

* Sun Apr 12 2009 Paul Fox <pgf@laptop.org>
- 4-1
- add control over sleep on lid-close
- resync version numbers

* Sat Apr 11 2009 Paul Fox <pgf@laptop.org>
- 3-3
- fixed powerd-config behavior wrt symlinked configs

* Fri Apr 10 2009 Paul Fox <pgf@laptop.org>
- 3-2
- fix bugs, implement cpu idleness check, and add suspend inhibit mechanism

* Tue Apr 7 2009 Paul Fox <pgf@laptop.org>
- 3-1
- convert to HAL-based operation

* Thu Mar 19 2009 Paul Fox <pgf@laptop.org
- 2-3
- removed extra dcon calls.

* Thu Mar 19 2009 Paul Fox <pgf@laptop.org
- 2-2
- bug fixing

* Tue Mar 17 2009 Paul Fox <pgf@laptop.org
- 2-1 
- added powerd-config, and added blank-or-shutdown after sleep
  capability

* Fri Mar 13 2009 Paul Fox <pgf@laptop.org>
- 1-2
- fix rpmlint errors, move daemons to /usr/sbin

